var config = {baseUrl:'http://www.nudgecouples.com',clientUrl:'http://www.nudgecouples.com/client'};

angular.module('starter.controllers', ['ui.router'])

.controller('defaultCntrl', function($scope, $location, $state,$sce,$http, $ionicLoading) {
	 $scope.goToNudges = function() {
		  //$location.path("/nudges");
		   $state.go("nudges");
	 };
	$scope.trustAsHtml = function(string) {
		return $sce.trustAsHtml(string);
	};
	
	$ionicLoading.show({
          template: '<i class="icon ion-loading-d" style="font-size: 32px"></i><br>Loading..',
    	});
		//$http.post(config.clientUrl+'/getCMS').
		$http.post(config.clientUrl+'/getWelcomePage').		
			  success(function(data, status, headers, config) {
				   $ionicLoading.hide();
				   $scope.welcome_content = data[0].content;
				   $scope.welcome_title  = data[0].title ;
			  }).
			  error(function(data, status, headers, config) {
				alert("Couldn't connect with server !!!");
		}); 
	
})
.controller('nudgeDetailCntrl', function($scope, $location, $state, $ionicModal, $http, $stateParams, $ionicScrollDelegate,$ionicLoading,$ionicPopup) {
	 $scope.toptitle = 'ADVENTURES'; 
	// $scope.conpletedNudge = [];
	//
	$scope.goToNudgeDetail = function(id,prnd) {
		
		if(prnd == 0 || (prnd > 0 && $scope.containsObject(prnd))) {
			$state.go("nudge",{nd:id,sb:1}, {reload: true});
		}
		else{
			$ionicPopup.alert({
				title: 'Nudgecouples',
				template: '<span class="text-center">To show this Nudge, you need to completed previous one.!!!</span>'
			});
			return false;	
		}
	 };
	//######## get completed Nudges#########
	 $scope.conpletedNudgeSaved = localStorage.getItem('completed_nudge');
		
	 if($scope.conpletedNudgeSaved && $scope.conpletedNudgeSaved != 'null'){
		$scope.conpletedNudge = JSON.parse($scope.conpletedNudgeSaved);
		
	 }
		
   // Object contais checking
	 $scope.containsObject = function(obj) {	
	 
		$scope.conpletedNudgeSaved = localStorage.getItem('completed_nudge');
		if($scope.conpletedNudgeSaved && $scope.conpletedNudgeSaved != 'null'){
			$scope.conpletedNudge = JSON.parse($scope.conpletedNudgeSaved);
			var i;
			for (i = 0; i < $scope.conpletedNudge.length; i++) {
				if (angular.equals(parseInt($scope.conpletedNudge[i]), parseInt(obj))) {
					return true;
				}
			}
		}
	
		return false;
	 };
	 
	 // Go to bottom function
	 $scope.goToBottom = function() {
		$ionicScrollDelegate.scrollBottom();
	 };
	 
	 // Default functions
	 $ionicLoading.show({
          template: '<i class="icon ion-loading-d" style="font-size: 32px"></i><br>Loading..',
    	 });
		 
	 $http.post(config.clientUrl+'/getActiveNudges').
		  success(function(data, status, headers, config) {
			 
			  
			  $ionicLoading.hide();
			  $scope.results  = data;
			  $ionicScrollDelegate.scrollTop();
		  }).
		  error(function(data, status, headers, config) {
			alert("Couldn't connect with server !!!");
			$state.go("home");
		  });
		  
	
	 
})

.controller('getCMS', function( $scope, $location, $state, $http,$sce, $stateParams,$ionicScrollDelegate,$ionicLoading) {
		
	$scope.toptitle = 'ADVENTURES';
	$scope.alias = 'adventures';
	$scope.obj = {};
	$scope.conpletedNudge = [];
	$scope.nudgeId = $stateParams.nd;
	$scope.conpletedNudgeSaved = localStorage.getItem('completed_nudge');
	if($scope.conpletedNudgeSaved && $scope.conpletedNudgeSaved != 'null'){
		$scope.conpletedNudge = JSON.parse($scope.conpletedNudgeSaved);
	}
		
	
	  
	$scope.trustAsHtml = function(string) {
		return $sce.trustAsHtml(string);
	};
	//####################localstorage######################
	$scope.saveRating = function(sec_id,rank) {
		
		$scope.saved = localStorage.getItem('ranks');
		if($scope.saved && $scope.saved != 'null'){
			$scope.obj = JSON.parse($scope.saved);
		}
		$scope.obj[ sec_id ] = rank;
		
		localStorage.setItem('ranks', JSON.stringify($scope.obj));
		
		
		angular.element('.'+sec_id).removeClass('selected')
		angular.forEach(angular.element('.'+sec_id), function(value, key){
			if(key <= rank-1){
			 	var a = angular.element(value);
			 	a.addClass('selected');
			}
		});
		
		//Update App Rank
		$scope.getAppRank();
		return;
	};
	//############ Nudge Completed #############
	$scope.markComplete = function(nd){
		if(!nd) return true;

		$scope.conpletedNudgeSaved = localStorage.getItem('completed_nudge');
		
		if($scope.conpletedNudgeSaved && $scope.conpletedNudgeSaved != 'null'){
			$scope.conpletedNudge = JSON.parse($scope.conpletedNudgeSaved);
		}
		
		if(!$scope.isItCompleted(nd)){
			$scope.conpletedNudge.push(nd );
		}
		localStorage.setItem('completed_nudge', JSON.stringify($scope.conpletedNudge));
		$state.go("nudges");
		
		//$state.transitionTo('nudges', null, {'reload':true});
		
		
	};
	
	// Object contais checking
	
	$scope.isItCompleted = function(obj) {
		
		$scope.conpletedNudgeSaved = localStorage.getItem('completed_nudge');
		if($scope.conpletedNudgeSaved && $scope.conpletedNudgeSaved != 'null'){
			$scope.conpletedNudge = JSON.parse($scope.conpletedNudgeSaved);
			var i;
			for (i = 0; i < $scope.conpletedNudge.length; i++) {
				if (angular.equals(parseInt($scope.conpletedNudge[i]), parseInt(obj))) {
					return true;
				}
			}
		}
	
		return false;
	};
	
	//############ get Application Rank #############
	$scope.getAppRank = function(){
		$scope.saved = localStorage.getItem('ranks');
		$scope.App_rank = 0;
		if($scope.saved && $scope.saved!= 'null'){
			$scope.ranks = JSON.parse($scope.saved);
			
			angular.forEach($scope.ranks, function(index,val){
				$scope.App_rank += parseInt(index) << 0;
			});
		}		
		return ;
	};
	
	/*$scope.goToHome = function() {
		$state.go("nudges");
	};*/
	//################# get content ajax ##############
	$scope.goTosubContent = function(nd,sb,path) {
		 $scope.nudgeId = nd;
		 $scope.alias = path;
		 $ionicLoading.show({
          template: '<i class="icon ion-loading-d" style="font-size: 32px"></i><br>Loading..',
    	 });
		 $http.post(config.clientUrl+'/getCMS', {'nudge_id':nd,'sub_id':sb}).
		  success(function(data, status, headers, config) {
			  $ionicLoading.hide();
			  $scope.submenu = data[0];
			  $scope.results  = data;
			  $ionicScrollDelegate.scrollTop();
		  }).
		  error(function(data, status, headers, config) {
			alert("Couldn't connect with server !!!");
			$state.go("home");
		  });
		return true;
	 };
	
	//################ check whether file exists $####################
	$scope.imageExists = function(image) {
		if(image) {  
			var url = config.baseUrl + '/assets/uploads/nudge_sections/'+image;
			var request = new XMLHttpRequest();
			request.open('HEAD', url, false);
			request.send();
			if(request.status == 200) {
				return config.baseUrl + '/assets/uploads/nudge_sections/'+image;
			} else {
				return  false;
			}
		} else {
			return false;
		}
	};
	
	if($stateParams.nd && $stateParams.sb){

		$ionicLoading.show({
          template: '<i class="icon ion-loading-d" style="font-size: 32px"></i><br>Loading..',
    	});
		//$http.post(config.clientUrl+'/getCMS').
		$http.post(config.clientUrl+'/getCMS', {'nudge_id':$stateParams.nd,'sub_id':$stateParams.sb}).		
			  success(function(data, status, headers, config) {
				   $ionicLoading.hide();
				   $scope.submenu = data[0];
				   $scope.results  = data;
				   $ionicScrollDelegate.scrollTop();
			  }).
			  error(function(data, status, headers, config) {
				alert("Couldn't connect with server !!!");
				$state.go("home");
		});
	}
	
	
	
	//######### Get saved Ranks
	
	$scope.getAppRank(); // calculate app rank
	
	
});
